<template>
  <v-navigation-drawer
    app
    clipped
    v-model="drawer"
    :mini-variant="!applicationStore.drawer"
    :width="sidebarWidth"
    :permanent="$vuetify.breakpoint.mdAndUp"
    :temporary="$vuetify.breakpoint.smAndDown"
    :mini-variant-width="sidebarMinWidth"
    :class="{'drawer-mini': !applicationStore.drawer}">
    <v-list>
      <template v-for="(item, i) in items">
        <v-row
          v-if="item.heading"
          :key="item.heading"
          align="center">
          <v-col cols="6">
            <span
              style="padding-left: 32px"
              class="text-body-1 subheader"
              :class="(item.heading && applicationStore.drawer) ? 'show ' : 'hide'">
              {{ item.heading }}
              </span>
          </v-col>
          <v-col
            cols="6"
            class="text-center">
          </v-col>
        </v-row>
        <v-divider
          v-else-if="item.divider"
          :key="i"
          dark
          class="my-4"
        ></v-divider>
        <v-list-group
          color="primary"
          v-else-if="item.children && applicationStore.drawer"
          :key="item.title"
          v-model="item.model"
          append-icon="">
            <template v-slot:prependIcon>
              <v-icon size="28">mdi-image-filter-none</v-icon>
            </template>
            <template v-slot:activator >
              <v-list-item-content >
                <v-list-item-title
                  class="grey--text">
                    {{ item.title }}
                </v-list-item-title>
              </v-list-item-content>
            </template>
            <v-list-item
              v-for="(child, i) in item.children"
              :key="i"
              :to="child.link"
              link>
                <v-list-item-action v-if="child.icon">
                  <v-icon size="">{{ child.icon }}</v-icon>
                </v-list-item-action>
                <v-list-item-content>
                  <v-list-item-title class="grey--text">
                    {{ child.title }}
                  </v-list-item-title>
                </v-list-item-content>
            </v-list-item>
        </v-list-group>
        <v-list-item
          color="primary"
          v-else
          :key="item.text"
          :to="item.link === '#' ? null : item.link"
          link>
          <v-list-item-action>
            <v-icon
              size="28"
              :color="item.color ? item.color : ''"
            >{{ item.icon }}</v-icon>
          </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title
                class="grey--text"
                link>
                {{ item.title }}
              </v-list-item-title>
            </v-list-item-content>
        </v-list-item>
      </template>
    </v-list>
    </v-navigation-drawer>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
import ApplicationModule from '@/store/modules/application';
import { getModule } from 'vuex-module-decorators';

@Component
export default class Sidebar extends Vue {
  @Prop() public source!: string;
  private applicationStore = getModule(ApplicationModule, this.$store);

  private items = [
    { title: 'Бакалавриат', icon: 'mdi-home', link: '/bacelours' },
    { title: 'Магистратура', icon: 'mdi-format-size', link: '/magistracy' },
    { title: 'Специалитет', icon: 'mdi-grid-large', link: '/speciality' },

  ];
  private sidebarWidth = 240;
  private sidebarMinWidth = 96;

  protected get drawer(): boolean {
    return this.applicationStore.drawer;
  }

  protected set drawer(newValue: boolean) {
    if (newValue === this.applicationStore.drawer) {
      return;
    }
    this.applicationStore.toggleDrawer();
  }
}
</script>

<style src="./Sidebar.scss" lang="scss"/>
